about summary refs log tree commit diff
path: root/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xtools/perf-flamegraph-pid/perf-flamegraph-pid.sh20
1 files changed, 20 insertions, 0 deletions
diff --git a/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh b/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh
new file mode 100755
index 0000000..141ceec
--- /dev/null
+++ b/tools/perf-flamegraph-pid/perf-flamegraph-pid.sh
@@ -0,0 +1,20 @@
+#!/usr/bin/env bash
+
+set -euo pipefail
+
+OUT_DIR="${HOME}/workspace/debug/flamegraph"
+OUT_DATA="${OUT_DIR}/$(date +%y%m%d-%H%M%S).data"
+OUT_SVG="${OUT_DIR}/$(date +%y%m%d-%H%M%S).svg"
+
+mkdir -p "${OUT_DIR}"
+
+# record the data with perf. We need to run this with sudo to get all
+# the privileges we need.
+sudo perf record -g --call-graph dwarf --freq max --output "${OUT_DATA}" "$@"
+
+# give me ownership of the file
+sudo chown "${USER}" "${OUT_DATA}"
+
+perf script --input "${OUT_DATA}" | \
+     stackcollapse-perf.pl | \
+     flamegraph.pl > "${OUT_SVG}"